"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Dropdown/Dropdown.tsx
var Dropdown_exports = {};
__export(Dropdown_exports, {
  default: () => Dropdown_default
});
module.exports = __toCommonJS(Dropdown_exports);
var import_react = require("react");
var import_classnames2 = __toESM(require("classnames"));

// src/Button/Button.tsx
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime = require("react/jsx-runtime");
var Button = (_a) => {
  var _b = _a, {
    disabled = false,
    backgroundColor = "#3979aa",
    color = "white"
  } = _b, props = __objRest(_b, [
    "disabled",
    "backgroundColor",
    "color"
  ]);
  var _a2, _b2;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "button",
    {
      type: (_a2 = props == null ? void 0 : props.type) != null ? _a2 : "button",
      ref: props.buttonRef,
      title: props.title,
      className: (0, import_classnames.default)("rce-button", props.type, props.className),
      style: {
        backgroundColor,
        color,
        borderColor: backgroundColor
      },
      disabled,
      onClick: props.onClick,
      children: props.icon ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("span", { className: "rce-button-icon--container", children: [
        (props.icon.float === "right" || !props.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { children: props.text }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "span",
          {
            style: {
              float: (_b2 = props.icon.float) != null ? _b2 : "inherit",
              fontSize: props.icon.size || 12
            },
            className: "rce-button-icon",
            children: props.icon.component
          }
        ),
        props.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { children: props.text })
      ] }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { children: props.text })
    }
  );
};
var Button_default = Button;

// src/Dropdown/Dropdown.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var Dropdown = (_a) => {
  var _b = _a, {
    animationPosition = "nortwest",
    animationType = "default"
  } = _b, props = __objRest(_b, [
    "animationPosition",
    "animationType"
  ]);
  var _a2;
  const [show, setShow] = (0, import_react.useState)(void 0);
  const onBlur = () => {
    if (show === true) setShow(false);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "div",
    {
      className: (0, import_classnames2.default)("rce-dropdown-container", props.className),
      onBlur,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Button_default, __spreadProps(__spreadValues({}, props.buttonProps), { onClick: () => setShow(!show) })),
        /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "div",
          {
            className: (0, import_classnames2.default)(
              "rce-dropdown",
              animationType,
              `rce-dropdown-open__${animationPosition}`,
              { "dropdown-hide": show === false },
              { "dropdown-show": show === true }
            ),
            children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("ul", { children: [
              props.title && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-dropdown-title", children: props.title }),
              (_a2 = props.items) == null ? void 0 : _a2.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "li",
                {
                  onMouseDown: (e) => props.onSelect instanceof Function ? props.onSelect(e, i) : void 0,
                  children: typeof x !== "string" ? x.icon ? /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("span", { className: "rce-button-icon--container", children: [
                    (x.icon.float === "right" || !x.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("button", { type: "button", className: "rce-button-link", children: x.text }),
                    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                      "span",
                      {
                        style: {
                          float: x.icon.float,
                          color: x.icon.color,
                          fontSize: x.icon.size || 12
                        },
                        className: (0, import_classnames2.default)(
                          "rce-button-icon",
                          x.icon.className
                        ),
                        children: x.icon.component
                      }
                    ),
                    x.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("button", { type: "button", className: "rce-button-link", children: x.text })
                  ] }) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("button", { type: "button", className: "rce-button-link", children: x.text }) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("button", { type: "button", className: "rce-button-link", children: x })
                },
                i.toString()
              ))
            ] })
          }
        )
      ]
    }
  );
};
var Dropdown_default = Dropdown;
