"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/SpotifyMessage/SpotifyMessage.tsx
var SpotifyMessage_exports = {};
__export(SpotifyMessage_exports, {
  default: () => SpotifyMessage_default
});
module.exports = __toCommonJS(SpotifyMessage_exports);
var import_jsx_runtime = require("react/jsx-runtime");
var SpotifyMessage = (_a) => {
  var _b = _a, {
    width = 300,
    height = 380
  } = _b, props = __objRest(_b, [
    "width",
    "height"
  ]);
  const toUrl = () => {
    const formBody = [];
    for (const property in props) {
      const encodedKey = encodeURIComponent(property);
      const encodedValue = encodeURIComponent(props[property]);
      formBody.push(`${encodedKey}=${encodedValue}`);
    }
    return formBody.join("&");
  };
  if (!props.uri) return null;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "rce-mbox-spotify", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "iframe",
    {
      title: "Spotify",
      src: `https://open.spotify.com/embed?${toUrl()}`,
      width,
      height
    }
  ) });
};
var SpotifyMessage_default = SpotifyMessage;
