import {
  __objRest,
  __spreadValues
} from "./chunk-FWCSY2DS.mjs";

// src/ReplyMessage/ReplyMessage.tsx
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var ReplyMessage = (_a) => {
  var _b = _a, { onClick } = _b, props = __objRest(_b, ["onClick"]);
  return /* @__PURE__ */ jsxs(
    "div",
    {
      className: classNames("rce-mbox-reply", {
        "rce-mbox-reply-border": !!props.titleColor
      }),
      style: __spreadValues({}, props.titleColor && { borderColor: props.titleColor }),
      onClick,
      onKeyDown: console.log,
      children: [
        /* @__PURE__ */ jsxs("div", { className: "rce-mbox-reply-left", children: [
          /* @__PURE__ */ jsx(
            "div",
            {
              style: __spreadValues({}, props.titleColor && { color: props.titleColor }),
              className: "rce-mbox-reply-owner",
              children: props.title || "Unknown"
            }
          ),
          /* @__PURE__ */ jsx("div", { className: "rce-mbox-reply-message", children: props.message || "..." })
        ] }),
        props.photoURL && /* @__PURE__ */ jsx("div", { className: "rce-mbox-reply-right", children: /* @__PURE__ */ jsx("img", { src: props.photoURL, alt: "" }) })
      ]
    }
  );
};
var ReplyMessage_default = ReplyMessage;

export {
  ReplyMessage_default
};
