import {
  icons_default
} from "./chunk-3KRCX26U.mjs";

// src/SvgIcon/leftNotch.tsx
import classNames from "classnames";
import { jsx } from "react/jsx-runtime";
var LeftNotch = ({
  notchStyle = {},
  focus = false
}) => {
  return /* @__PURE__ */ jsx(
    icons_default,
    {
      style: notchStyle,
      className: classNames("rce-mbox-left-notch", {
        "message-focus": focus
      }),
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 20 20",
      children: /* @__PURE__ */ jsx("path", { d: "M20 0v20L0 0", filter: "url(#filter1)" })
    }
  );
};

export {
  LeftNotch
};
