import {
  __objRest
} from "./chunk-FWCSY2DS.mjs";

// src/Button/Button.tsx
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var Button = (_a) => {
  var _b = _a, {
    disabled = false,
    backgroundColor = "#3979aa",
    color = "white"
  } = _b, props = __objRest(_b, [
    "disabled",
    "backgroundColor",
    "color"
  ]);
  var _a2, _b2;
  return /* @__PURE__ */ jsx(
    "button",
    {
      type: (_a2 = props == null ? void 0 : props.type) != null ? _a2 : "button",
      ref: props.buttonRef,
      title: props.title,
      className: classNames("rce-button", props.type, props.className),
      style: {
        backgroundColor,
        color,
        borderColor: backgroundColor
      },
      disabled,
      onClick: props.onClick,
      children: props.icon ? /* @__PURE__ */ jsxs("span", { className: "rce-button-icon--container", children: [
        (props.icon.float === "right" || !props.icon.float) && /* @__PURE__ */ jsx("span", { children: props.text }),
        /* @__PURE__ */ jsx(
          "span",
          {
            style: {
              float: (_b2 = props.icon.float) != null ? _b2 : "inherit",
              fontSize: props.icon.size || 12
            },
            className: "rce-button-icon",
            children: props.icon.component
          }
        ),
        props.icon.float === "left" && /* @__PURE__ */ jsx("span", { children: props.text })
      ] }) : /* @__PURE__ */ jsx("span", { children: props.text })
    }
  );
};
var Button_default = Button;

export {
  Button_default
};
