import {
  ChatItem_default
} from "./chunk-CMAHLPPN.mjs";
import {
  __spreadProps,
  __spreadValues
} from "./chunk-FWCSY2DS.mjs";

// src/ChatList/ChatList.tsx
import classNames from "classnames";
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import { createElement } from "react";
var list = [];
var ChatList = (props) => {
  const onClick = (item, index, event) => {
    if (props == null ? void 0 : props.onClick) {
      props == null ? void 0 : props.onClick(item, index, event);
    }
  };
  const onContextMenu = (item, index, event) => {
    if (props.onContextMenu instanceof Function)
      props.onContextMenu(item, index, event);
  };
  const onAvatarError = (item, index, event) => {
    if (props.onAvatarError instanceof Function)
      props.onAvatarError(item, index, event);
  };
  const setDragStates = (state) => {
    list.push(state);
  };
  const onDragLeaveMW = (e, id) => {
    var _a;
    if (list.length > 0)
      for (const item of list) {
        item instanceof Function && item(false);
      }
    (_a = props.onDragLeave) == null ? void 0 : _a.call(props, e, id.toString());
  };
  const onExpand = (item, index, event) => {
    if (props.onExpand instanceof Function) props.onExpand(item, index, event);
  };
  return /* @__PURE__ */ jsx("div", { className: classNames("rce-container-clist", props.className), children: props.dataSource ? props.dataSource.map((x, i) => /* @__PURE__ */ jsxs("div", { children: [
    /* @__PURE__ */ jsx(
      ChatItem_default,
      __spreadProps(__spreadValues({}, x), {
        lazyLoadingImage: props == null ? void 0 : props.lazyLoadingImage,
        onAvatarError: (e) => onAvatarError(x, i, e),
        onContextMenu: (e) => onContextMenu(x, i, e),
        onClick: (e) => onClick(x, i, e),
        onClickMute: (e) => {
          var _a;
          return (_a = props.onClickMute) == null ? void 0 : _a.call(props, x, i, e);
        },
        onClickVideoCall: (e) => {
          var _a;
          return (_a = props.onClickVideoCall) == null ? void 0 : _a.call(props, x, i, e);
        },
        onDragOver: props == null ? void 0 : props.onDragOver,
        onDragEnter: props == null ? void 0 : props.onDragEnter,
        onDrop: props.onDrop,
        onDragLeave: (e) => onDragLeaveMW(e, i),
        onDragComponent: props.onDragComponent,
        setDragStates,
        onExpandItem: (e) => onExpand(x, i, e),
        expanded: x.expanded
      })
    ),
    x.subList && x.subList.length > 0 && /* @__PURE__ */ jsx(Fragment, { children: x.expanded && x.subList.map((sub, j) => /* @__PURE__ */ createElement(
      ChatItem_default,
      __spreadProps(__spreadValues({}, sub), {
        className: "subitem",
        avatarSize: "xsmall",
        key: `${i}-${j.toString()}`,
        lazyLoadingImage: props == null ? void 0 : props.lazyLoadingImage,
        onAvatarError: (e) => onAvatarError(sub, j, e),
        onContextMenu: (e) => onContextMenu(sub, j, e),
        onClick: (e) => onClick(sub, j, e),
        onClickMute: (e) => {
          var _a;
          return (_a = props.onClickMute) == null ? void 0 : _a.call(props, sub, j, e);
        },
        onClickVideoCall: (e) => {
          var _a;
          return (_a = props.onClickVideoCall) == null ? void 0 : _a.call(props, sub, j, e);
        },
        onDragOver: props == null ? void 0 : props.onDragOver,
        onDragEnter: props == null ? void 0 : props.onDragEnter,
        onDrop: props.onDrop,
        onDragLeave: onDragLeaveMW,
        onDragComponent: props.onDragComponent,
        setDragStates
      })
    )) })
  ] }, i.toString())) : null });
};
var ChatList_default = ChatList;

export {
  ChatList_default
};
