import {
  MAP_URL,
  STATIC_URL
} from "./chunk-R6GSUT3Y.mjs";
import {
  __objRest
} from "./chunk-FWCSY2DS.mjs";

// src/LocationMessage/LocationMessage.tsx
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var LocationMessage = (_a) => {
  var _b = _a, {
    markerColor = "red",
    target = "_blank",
    zoom = "14"
  } = _b, props = __objRest(_b, [
    "markerColor",
    "target",
    "zoom"
  ]);
  var _a2, _b2;
  const buildURL = (url) => {
    var _a3, _b3, _c, _d, _e;
    return url.replace(/LATITUDE/g, (_b3 = (_a3 = props == null ? void 0 : props.data) == null ? void 0 : _a3.latitude.toString()) != null ? _b3 : "0").replace(/LONGITUDE/g, (_d = (_c = props == null ? void 0 : props.data) == null ? void 0 : _c.longitude.toString()) != null ? _d : "0").replace("MARKER_COLOR", markerColor).replace("ZOOM", zoom).replace("KEY", (_e = props == null ? void 0 : props.apiKey) != null ? _e : "");
  };
  const className = () => {
    let _className = classNames("rce-mbox-location", props.className);
    if (props.text) {
      _className = classNames(_className, "rce-mbox-location-has-text");
    }
    return _className;
  };
  return /* @__PURE__ */ jsxs("div", { className: "rce-container-lmsg", children: [
    /* @__PURE__ */ jsx(
      "a",
      {
        onClick: props.onOpen,
        target,
        href: props.href || props.src || buildURL(((_a2 = props.data) == null ? void 0 : _a2.mapURL) || MAP_URL),
        className: className(),
        children: /* @__PURE__ */ jsx(
          "img",
          {
            alt: props.alt,
            onError: props.onError,
            className: "rce-mbox-location-img",
            src: props.src || buildURL(((_b2 = props.data) == null ? void 0 : _b2.staticURL) || STATIC_URL)
          }
        )
      }
    ),
    props.text && /* @__PURE__ */ jsx("div", { className: "rce-mbox-text rce-mbox-location-text", children: props.text })
  ] });
};
var LocationMessage_default = LocationMessage;

export {
  LocationMessage_default
};
