import {
  Button_default
} from "./chunk-ESLU3NHL.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-FWCSY2DS.mjs";

// src/Dropdown/Dropdown.tsx
import { useState } from "react";
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var Dropdown = (_a) => {
  var _b = _a, {
    animationPosition = "nortwest",
    animationType = "default"
  } = _b, props = __objRest(_b, [
    "animationPosition",
    "animationType"
  ]);
  var _a2;
  const [show, setShow] = useState(void 0);
  const onBlur = () => {
    if (show === true) setShow(false);
  };
  return /* @__PURE__ */ jsxs(
    "div",
    {
      className: classNames("rce-dropdown-container", props.className),
      onBlur,
      children: [
        /* @__PURE__ */ jsx(Button_default, __spreadProps(__spreadValues({}, props.buttonProps), { onClick: () => setShow(!show) })),
        /* @__PURE__ */ jsx(
          "div",
          {
            className: classNames(
              "rce-dropdown",
              animationType,
              `rce-dropdown-open__${animationPosition}`,
              { "dropdown-hide": show === false },
              { "dropdown-show": show === true }
            ),
            children: /* @__PURE__ */ jsxs("ul", { children: [
              props.title && /* @__PURE__ */ jsx("span", { className: "rce-dropdown-title", children: props.title }),
              (_a2 = props.items) == null ? void 0 : _a2.map((x, i) => /* @__PURE__ */ jsx(
                "li",
                {
                  onMouseDown: (e) => props.onSelect instanceof Function ? props.onSelect(e, i) : void 0,
                  children: typeof x !== "string" ? x.icon ? /* @__PURE__ */ jsxs("span", { className: "rce-button-icon--container", children: [
                    (x.icon.float === "right" || !x.icon.float) && /* @__PURE__ */ jsx("button", { type: "button", className: "rce-button-link", children: x.text }),
                    /* @__PURE__ */ jsx(
                      "span",
                      {
                        style: {
                          float: x.icon.float,
                          color: x.icon.color,
                          fontSize: x.icon.size || 12
                        },
                        className: classNames(
                          "rce-button-icon",
                          x.icon.className
                        ),
                        children: x.icon.component
                      }
                    ),
                    x.icon.float === "left" && /* @__PURE__ */ jsx("button", { type: "button", className: "rce-button-link", children: x.text })
                  ] }) : /* @__PURE__ */ jsx("button", { type: "button", className: "rce-button-link", children: x.text }) : /* @__PURE__ */ jsx("button", { type: "button", className: "rce-button-link", children: x })
                },
                i.toString()
              ))
            ] })
          }
        )
      ]
    }
  );
};
var Dropdown_default = Dropdown;

export {
  Dropdown_default
};
