"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Circle/Circle.tsx
var Circle_exports = {};
__export(Circle_exports, {
  default: () => Circle_default
});
module.exports = __toCommonJS(Circle_exports);
var import_react = require("react");
var import_progressbar = require("progressbar.js");
var import_jsx_runtime = require("react/jsx-runtime");
var wrapper;
var ProgressCircle = ({
  animate,
  progressOptions,
  className,
  progress = 0
}) => {
  const animateProgress = (0, import_react.useMemo)(() => progress, [progress]);
  const bar = (0, import_react.useMemo)(() => {
    wrapper = document.createElement("div");
    return new import_progressbar.Circle(wrapper, progressOptions);
  }, [progressOptions]);
  const node = (0, import_react.useCallback)((node2) => {
    if (node2) {
      node2.appendChild(wrapper);
    }
  }, []);
  (0, import_react.useEffect)(() => {
    if (animate) {
      bar.animate(animateProgress);
    }
  }, [animate, animateProgress, bar]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className, ref: node });
};
var Circle_default = ProgressCircle;
