"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Popup/Popup.tsx
var Popup_exports = {};
__export(Popup_exports, {
  default: () => Popup_default
});
module.exports = __toCommonJS(Popup_exports);

// src/Button/Button.tsx
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime = require("react/jsx-runtime");
var Button = (_a) => {
  var _b = _a, {
    disabled = false,
    backgroundColor = "#3979aa",
    color = "white"
  } = _b, props = __objRest(_b, [
    "disabled",
    "backgroundColor",
    "color"
  ]);
  var _a2, _b2;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "button",
    {
      type: (_a2 = props == null ? void 0 : props.type) != null ? _a2 : "button",
      ref: props.buttonRef,
      title: props.title,
      className: (0, import_classnames.default)("rce-button", props.type, props.className),
      style: {
        backgroundColor,
        color,
        borderColor: backgroundColor
      },
      disabled,
      onClick: props.onClick,
      children: props.icon ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("span", { className: "rce-button-icon--container", children: [
        (props.icon.float === "right" || !props.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { children: props.text }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "span",
          {
            style: {
              float: (_b2 = props.icon.float) != null ? _b2 : "inherit",
              fontSize: props.icon.size || 12
            },
            className: "rce-button-icon",
            children: props.icon.component
          }
        ),
        props.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { children: props.text })
      ] }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { children: props.text })
    }
  );
};
var Button_default = Button;

// src/Popup/Popup.tsx
var import_classnames2 = __toESM(require("classnames"));
var import_jsx_runtime2 = require("react/jsx-runtime");
var Popup = (_a) => {
  var props = __objRest(_a, []);
  var _a2, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o;
  if (((_a2 = props.popup) == null ? void 0 : _a2.show) === true)
    return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
      "div",
      {
        className: (0, import_classnames2.default)("rce-popup-wrapper", props.type, props.className),
        children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-popup", children: [
          ((_b = props.popup) == null ? void 0 : _b.renderHeader) ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-popup-header", children: (_c = props.popup) == null ? void 0 : _c.renderHeader() }) : /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-popup-header", children: [
            /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: (_d = props.popup) == null ? void 0 : _d.header }),
            ((_e = props.popup) == null ? void 0 : _e.header) && ((_g = (_f = props.popup) == null ? void 0 : _f.headerButtons) == null ? void 0 : _g.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Button_default, __spreadValues({}, x), i.toString())))
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            "div",
            {
              className: "rce-popup-content",
              style: { color: (_h = props.popup) == null ? void 0 : _h.color },
              children: ((_i = props.popup) == null ? void 0 : _i.renderContent) ? (_j = props.popup) == null ? void 0 : _j.renderContent() : (_k = props.popup) == null ? void 0 : _k.text
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-popup-footer", children: ((_l = props.popup) == null ? void 0 : _l.renderFooter) ? (_m = props.popup) == null ? void 0 : _m.renderFooter() : (_o = (_n = props.popup) == null ? void 0 : _n.footerButtons) == null ? void 0 : _o.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Button_default, __spreadValues({}, x), i.toString())) })
        ] })
      }
    );
  return null;
};
var Popup_default = Popup;
