import {
  icons_default
} from "../chunk-3KRCX26U.mjs";
import "../chunk-FWCSY2DS.mjs";

// src/SvgIcon/arrowRight.tsx
import { jsx } from "react/jsx-runtime";
var ArrowRight = (size = 20) => {
  const backgroundSize = `new 0 0 ${size} ${size}`;
  return /* @__PURE__ */ jsx(
    icons_default,
    {
      x: "0px",
      y: "0px",
      viewBox: `0 0 ${size} ${size}`,
      enableBackground: backgroundSize,
      children: /* @__PURE__ */ jsx("polygon", { points: `0,0 0,${size} ${size},0` })
    }
  );
};
export {
  ArrowRight
};
