import {
  MeetingItem_default
} from "./chunk-DDNN2QEX.mjs";
import {
  __spreadProps,
  __spreadValues
} from "./chunk-FWCSY2DS.mjs";

// src/MeetingList/MeetingList.tsx
import classNames from "classnames";
import { jsx } from "react/jsx-runtime";
import { createElement } from "react";
var MeetingList = (props) => {
  var _a;
  const onClick = (item, index, event) => {
    if (props.onClick instanceof Function) props.onClick(item, index, event);
  };
  const onContextMenu = (item, index, event) => {
    event.preventDefault();
    if (props.onContextMenu instanceof Function)
      props.onContextMenu(item, index, event);
  };
  const onAvatarError = (item, index, event) => {
    if (props.onAvatarError instanceof Function)
      props.onAvatarError(item, index, event);
  };
  const onMeetingClick = (item, index, event) => {
    if (props.onMeetingClick instanceof Function)
      props.onMeetingClick(item, index, event);
  };
  const onShareClick = (item, index, event) => {
    if (props.onShareClick instanceof Function)
      props.onShareClick(item, index, event);
  };
  const onCloseClick = (item, index, event) => {
    if (props.onCloseClick instanceof Function)
      props.onCloseClick(item, index, event);
  };
  return /* @__PURE__ */ jsx(
    "div",
    {
      ref: props.cmpRef,
      className: classNames("rce-container-mtlist", props.className),
      children: (_a = props.dataSource) == null ? void 0 : _a.map((x, i) => /* @__PURE__ */ createElement(
        MeetingItem_default,
        __spreadProps(__spreadValues({}, x), {
          key: i,
          lazyLoadingImage: props.lazyLoadingImage,
          onAvatarError: (e) => onAvatarError(x, i, e),
          onContextMenu: (e) => onContextMenu(x, i, e),
          onClick: (e) => onClick(x, i, e),
          onMeetingClick: (e) => onMeetingClick(x, i, e),
          onShareClick: (e) => onShareClick(x, i, e),
          onCloseClick: (e) => onCloseClick(x, i, e)
        })
      ))
    }
  );
};
var MeetingList_default = MeetingList;

export {
  MeetingList_default
};
