import {
  __objRest
} from "./chunk-FWCSY2DS.mjs";

// src/SpotifyMessage/SpotifyMessage.tsx
import { jsx } from "react/jsx-runtime";
var SpotifyMessage = (_a) => {
  var _b = _a, {
    width = 300,
    height = 380
  } = _b, props = __objRest(_b, [
    "width",
    "height"
  ]);
  const toUrl = () => {
    const formBody = [];
    for (const property in props) {
      const encodedKey = encodeURIComponent(property);
      const encodedValue = encodeURIComponent(props[property]);
      formBody.push(`${encodedKey}=${encodedValue}`);
    }
    return formBody.join("&");
  };
  if (!props.uri) return null;
  return /* @__PURE__ */ jsx("div", { className: "rce-mbox-spotify", children: /* @__PURE__ */ jsx(
    "iframe",
    {
      title: "Spotify",
      src: `https://open.spotify.com/embed?${toUrl()}`,
      width,
      height
    }
  ) });
};
var SpotifyMessage_default = SpotifyMessage;

export {
  SpotifyMessage_default
};
