import {
  icons_default
} from "./chunk-3KRCX26U.mjs";

// src/SvgIcon/rightNotch.tsx
import classNames from "classnames";
import { jsx } from "react/jsx-runtime";
var RightNotch = ({
  notchStyle = {},
  focus = false
}) => {
  return /* @__PURE__ */ jsx(
    icons_default,
    {
      style: notchStyle,
      className: classNames("rce-mbox-right-notch", {
        "message-focus": focus
      }),
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 20 20",
      children: /* @__PURE__ */ jsx("path", { d: "M0 0v20L20 0" })
    }
  );
};

export {
  RightNotch
};
